#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <time.h>
#include "prn_to_krs_proto.h"

#define PRNDIR "/root/download/financial/data/datei"
#define KRSDIR "/root/stockvac2"

int debug_flag;

#define NEW_DATA 1
#define READSIZE 65535
#define TEMPSIZE 65535

/* for new_data in update_krs_file() */
#define NEW_DATA		1
#define CLOSED			2
#define EX_DIVIDENT		4

int mdays[13] = {0,31,28,31,30,31,30,31,31,30,31,30,31};
char *month_name[]=\
{"illegal","jan","feb","mrt","apr","mei","jun","jul",\
"aug","sep","okt","nov","dec"};
char *day[] = {"ma","di","wo","do","vr","za","zo"};
char *day_name[] = {"zo", "ma", "di", "wo", "do", "vr", "za"};


char *strsave(char *s) /* save char array s somewhere */
{
char *p;

p = malloc(strlen(s) +  1);
if(p) strcpy(p, s);
return(p);
}/* end function strsave */


int readline(FILE *file, char *contents)
{
int a, c, i;

for(i = 0; i < READSIZE - 1; i++)
	{
	while(1)
		{
		c = getc(file);
		a = ferror(file);
		if(a)
			{
			perror("readline():");
			continue;
			}
		break;
		}
	if(feof(file) )
		{
		fclose(file);
		contents[i] = 0;/* EOF marker */
		return(EOF);
		}
	if(c == '\n')
		{
		contents[i] = 0;/* string termination */
		return(1);/* end of line */
		} 
	contents[i] = c;
	}
/*
mmm since we are here, the line must be quite long, possibly something
is wrong.
Since I do not always check for a return 0 in the use uf this function,
just to be safe, gona force a string termination.
This prevents stack overflow, and variables getting overwritten.
*/
contents[i] = 0;/* force string termination */
/*fclose(file);*/
if(debug_flag)
	{
	fprintf(stdout,\
	"readline(): line to long, returning 0 contents=%s\n", contents);
	}
return(0);
}/* end function readline */


main(int argc, char **argv)
{
int a;
int i;
FILE *infptr;
FILE *outfptr;
char temp[512];
char field1[512];
char field2[512];
char field3[512];
char field4[512];
char field5[512];
char field6[512];
char field7[512];
char field8[512];
char *ptr;
float close_price;
int year;
int month;
int day_of_month;
long volume;
char fundname_lower_case[512];

debug_flag = 0;

fprintf(stdout, "Panteltje(c) prn_to_krs-1.0\n");

if(argc < 2)
	{
	fprintf(stdout, "Usage: prn_to_krs fund\n");
	exit(1);
	}

sprintf(temp, "%s/%s.prn", PRNDIR, argv[1]);
infptr = fopen (temp, "r");
if(! infptr)
	{
	fprintf(stdout, "Cannot open file %s for read\n", temp);
	exit(1);
	}

/* get fundname in lower case */
i = 0;
while(1)
	{
	fundname_lower_case[i] = tolower(argv[1][i]);
	if(! argv[i]) break;
	i++;
	}

sprintf(temp, "%s/%s.krs", KRSDIR, fundname_lower_case);
outfptr = fopen(temp, "w");
if(! outfptr)
	{
	fprintf(stdout, "Cannot open file %s for write\n", temp);
	exit(1);
	}

/* create header for new file with dummy data in the past */
fprintf(outfptr,\
"1900 jul 24 %s 1.0 0 500 0 32 7 8 .1 1000000 2 ", argv[1]); 
fclose(outfptr);

/* append close prices */
while(1)
	{
	a = readline(infptr, temp);
	if(a == EOF) break;

	/*
	PHI,D,990105,59.5000,58.2500,59.3000,2516904,58.8000
	*/

	ptr = strtok(temp, ",");/* PHI */ /* fundname */
	if(! ptr) continue;
	strcpy(field1, ptr);
	
	ptr = strtok(NULL, ",");/* D */ /* do not know */
	if(! ptr) continue;
	strcpy(field2, ptr);

	ptr = strtok(NULL, ",");/* 990105 */ /* date */
	if(! ptr) continue;
	strcpy(field3, ptr);
		
	ptr = strtok(NULL, ",");/* 59.5000 */ /* do not know */ 
	if(! ptr) continue;
	strcpy(field4, ptr);
	
	ptr = strtok(NULL, ",");/* 58.2500 */ /* do not know */
	if(! ptr) continue;
	strcpy(field5, ptr);
	
	ptr = strtok(NULL, ",");/* 59.3000 */ /* close price */
	if(! ptr) continue;
	strcpy(field6, ptr);
	
	ptr = strtok(NULL, ",");/* 2516904 */ /* volume */
	if(! ptr) continue;
	strcpy(field7, ptr);
	
	ptr = strtok(NULL, ",");/* 58.8000 */ /* do not know */
	if(! ptr) continue;
	strcpy(field8, ptr);
	
	if(debug_flag)
		{
		fprintf(stdout,\
		"parse_davief_option_file():\n\
		field1=%s\n\
		field2=%s\n\
		field3=%s\n\
		field4=%s\n\
		field5=%s\n\
		field6=%s\n\
		field7=%s\n\
		field8=%s\n",\
		field1, field2, field3, field4, field5, field6, field7, field8);
		}
	
	/* get year and date */
	sscanf(field3, "%2d%2d%2d", &year, &month, &day_of_month);
	year += 1900;
	
	close_price = atof(field6);
	fprintf(outfptr, "%.2f ", close_price);

	/* not used */
	volume = 0;

	update_krs_file(\
	fundname_lower_case, close_price, volume, year, month, day_of_month,\
	NEW_DATA);

	}/* end while read close prices from .csv file */

fclose(outfptr);

fprintf(stdout, "Ready\n");

exit(1);
}/* end main */


int update_krs_file(\
char *fundname, float close_price, long volume,\
int htm_file_year, int htm_file_month, int htm_file_day_of_month,\
int data_type)
{
int a, i;
float fa, fb;
char fiwd[10];/*weekday in header stockfile*/
char fimo[10];/*month in header stockfile*/
int fida;/*day in header stockfile*/
char path[READSIZE];
char ti[READSIZE];
char to[READSIZE];
char ta[READSIZE];
float fmaxk,fmink;
int xpos,ypos,lenfie,lenfr;
float trend;
int pg,sp,af;/*page subpage acq flag*/
FILE *krsf;
FILE *krsfb;
char si[80];/*scanf input string*/
char comstr[21];/*comment string for .krs file*/
char oldmonth[12];
int oldyear;
char temp[READSIZE];
int xcnt, xflag, xdeflag;
int special_field_appended_flag;
struct tm *htm_file_time;
struct tm *krs_file_time;
time_t new_data_time;
time_t old_data_time;
int krs_file_day_of_month;
int krs_file_month;
int krs_file_year;

if(debug_flag)
	{
	fprintf(stdout,\
	"update_krs_file(): arg fundname=%s close_price=%.2f volume=%ld\n\
	htm_file_year=%d htm_file_month=%d htm_file_day_of_month=%d\n\
	data_type=%d\n",\
	fundname, close_price, volume,\
	htm_file_year, htm_file_month, htm_file_day_of_month,\
	data_type);
	}

if(! fundname) return(0);

/* for gcc -Wall */
fb = 0;

/* calculate time_t new_data_time */
htm_file_time = (struct tm *) malloc(sizeof(struct tm) );
if(! htm_file_time) return(0);

htm_file_time -> tm_sec = 0;
htm_file_time -> tm_min = 0;
htm_file_time -> tm_hour = 0;
htm_file_time -> tm_mday = htm_file_day_of_month;
htm_file_time -> tm_mon = htm_file_month - 1;
htm_file_time -> tm_year = htm_file_year - 1900;
htm_file_time -> tm_isdst = -1;/* daylight savings time n.a. */
/* the following are not implemented (see /usr/include/time.h) */
/* htm_file_time -> tm_gmtoff = 0;*/
/* strcp(htm_file_time -> tm_zone, ""); */ /* time zone 3 letters */

new_data_time = mktime( (struct tm *)htm_file_time);

free(htm_file_time);

strcpy(path, KRSDIR);
sprintf(ti, "%s/%s.krs", path, fundname);/* source */	
sprintf(to, "%s/%s.tmp", path, fundname);/* to is fundname.tmp */	
sprintf(ta, "%s/%s.bak", path, fundname);/* ta will be ti renamed in .bak */	

/*open files*/
krsf=fopen(to,"w");/*krsf is fundname.tmp, dest*/
if(! krsf)
	{
	sprintf(temp,\
	"update_krs_file(): cannot open file %s for write\n", to);
	fprintf(stdout,"%s", temp);
	return(0);
	}

krsfb = fopen(ti,"r");/*krsfb is fundname.krs, source*/
if(! krsfb)
	{
	sprintf(temp,\
	"update_krs_file(): cannot open file %s for read\n", ti);

	fclose(krsf);/*temp was open*/

	fprintf(stdout, "%s", temp);
	return(0);
	}
			
fscanf(krsfb,\
"%s %s %d %s %f %d %d %d %d %d %d %f %f %d",\
fiwd,fimo,&fida,si,&trend,&af,&pg,&sp,&xpos,&ypos,&lenfie,\
&fmaxk,&fmink,&lenfr);/* get header from old file */

/* calculate time_t old_data_time (time last updated) */
/* 
Problem is that we do not have the year here from the file,
unles we read it first (last year).
Solution, from now on use fiwd (the day of week in Dutch) as year.
One could put old_data_time here, but not human readable.
So now 1998 okt 30 aab 1.00 etc. .
*/

krs_file_day_of_month = fida;
krs_file_month = -1;
for(i = 0; i <= 12; i++)/* 0 is illegal, 12 is dec */
	{
	if(strcmp(fimo, month_name[i]) == 0)
		{
		krs_file_month = i;
		break;
		}
	}
if(krs_file_month == -1)	
	{
	sprintf(temp,\
	"update_krs_file(): file %s invalid month %s\n",\
	ti, fimo);
	fprintf(stdout, "%s", temp);
	fclose(krsf);
	fclose(krsfb);
	return(0);
	}
krs_file_year = atoi(fiwd);

krs_file_time = (struct tm *) malloc(sizeof(struct tm) );
if(! krs_file_time) return(0);

krs_file_time -> tm_sec = 0;
krs_file_time -> tm_min = 0;
krs_file_time -> tm_hour = 0;
/*krs_file_time -> tm_wday = 0;*/ /* to be calculated */
krs_file_time -> tm_mday = krs_file_day_of_month;
krs_file_time -> tm_mon = krs_file_month - 1;
krs_file_time -> tm_year = krs_file_year - 1900;
krs_file_time -> tm_isdst = -1;/* daylight savings time n.a. */
/* the following are not implemented (see /usr/include/time.h) */
/* krs_file_time -> tm_gmtoff = 0;*/
/* strcp(krs_file_time -> tm_zone, ""); */ /* time zone 3 letters */

old_data_time = mktime( (struct tm *)krs_file_time);
free(krs_file_time);

/* check if file already updated on this date */

if(new_data_time <= old_data_time)
	{
	sprintf(temp,\
	"update_krs_file(): file %s, has already been updated\n", ti);
	fprintf(stdout, "%s", temp);
	fclose(krsf);
	fclose(krsfb);
	return(0);
	}

/* year new data from htm file */
sprintf(fiwd, "%d", htm_file_year);

/* write header to new file */
fprintf(krsf,"%s %s %d %s %4.2f %d %d %d %d %d %d %4.2f %4.2f %d ",\
fiwd, month_name[htm_file_month], htm_file_day_of_month, si,trend, af, pg, sp, xpos, ypos,\
lenfie, fmaxk, fmink, lenfr);

oldyear = 0;
fa = 0;/*reset text type flag*/
oldmonth[0] = 0; /* reset old month string */
xflag = 0;/*set for no ex div.*/
xcnt = 1; /*stock values (days) since last ex div.*/
special_field_appended_flag = 0;
while(1)/*copy rest of .bak file to .krs file*/
	{
	a = fscanf(krsfb,"%20s ", comstr);
	if(a == -1) break;/*EOF*/

	fprintf(krsf,"%s ",comstr);/*copy as string*/
	if(fa == -1)/*flag ind. text type month*/
		{
		strcpy(oldmonth, comstr);
		}
	if(fa == -2)/*comment*/
		{
		if(strstr(comstr,"X") != 0)/*ex div.*/
			{
			xflag=1;/*ex div. flag*/
			xcnt=1;/*reset the cnt*/
			}
		}
	if(fa == -3)/* flag indicates text type year */
		{
		oldyear = atoi(comstr);/*like 1996*/
		}
	fa = atof(comstr);/*fa=0 for non digits*/
	if(fa > 0)/*stock value read*/
		{
		if(xflag)xcnt++;
		/*days since last ex div.*/
		if(xcnt > 100)
			{
			xcnt=1;/*usally only once a year ex div*/
			xflag=0;/*no longer exdiv*/
			/*ready for next exdiv*/
			}
		fb=fa;/*remember last stock for repeat if closed*/
		}
	}/*end while copy all entries as string*/
			
/*append from here*/
/* the stock price */
if(data_type == NEW_DATA)/*new data was read*/
	{
	fprintf(krsf,"%.2f ", close_price);
	}
else /*negative values of units indicate special condition*/
	{
	if(data_type == CLOSED)/*text 'closed' was read */
					/*no trade, use prev value*/
		{
		fprintf(krsf,"%4.2f ", fb); /* repeat last value */
		}
	}

/* the special fields */
xdeflag = 0;/*reset last field is ex div entered flag*/
/* test for exdiv on this day */
if(data_type & EX_DIVIDENT)
	{
	if(! special_field_appended_flag)
		{
		if(!xflag)/*not already ex div*/
			{
			fprintf(krsf, "-2 X%d ", htm_file_day_of_month);
			xdeflag=1;/*set ex div entered as last field flag*/
			special_field_appended_flag = 1;
			}
		else /*was already exdiv*/
			{
			fprintf(stdout, \
"\nWARNING: X marker found, but already ex divident %d days ago, check.\n"\
			,xcnt);
			}
		}
	}/* end ex divident */

/* test if new month */
strcpy(comstr, month_name[htm_file_month]);/*month in alfa*/

if(strcmp(oldmonth, comstr) != 0)/*new month*/
	{
	if(!special_field_appended_flag)
		{
		/*
		if not just entered special field
		if special field was entered,
		print month next time
		in kra.exe:
		if 2 special fields after each other,
		txtptr[txtcnt] pointing to ex div
		field is overwritten with pointer
		to month field, so no X print in
		case 32
		*/
		fprintf(krsf,"-1 %s ",comstr);
		special_field_appended_flag = 1;
		}
	}/* end new month */
	
/* test if new year */
/* year insertion here using -3 below month, once in january */
if(htm_file_year != oldyear)/*year has changed*/
	{
	if(!special_field_appended_flag) /*not 2 special fields in row*/
		{
		fprintf(krsf, "-3 %d ", htm_file_year);/* append year field */
	  	oldyear = htm_file_year;
		special_field_appended_flag = 1;
		}
	}/* end new year */

fclose(krsf);/*close .tmp file (dest)*/
fclose(krsfb);/*close .krs file (source)*/

unlink(ta);/*erase any existing .bak file*/

i=rename(ti,ta);/*.krs into .bak*/
if(i == -1)
	{
	fprintf(stdout, "update_krs_file(): cannot rename file %s into %s\n",\
	ti,ta);
	return(0);
	}

i=rename(to,ti);/*.tmp into .krs*/
if(i == -1)
	{
	fprintf(stdout, "update_krs_file(): cannot rename file %s into %s\n",\
	to,ti);
	return(0);
	}

if (debug_flag)
	{
	fprintf(stdout, "update_krs_file(): file %s has been updated\n", ti);
	}

return(1);
}/* end function update_krs_file */


